#ifndef __API_EX_H__
#define __API_EX_H__

#include "global.h"
#include "usb_hlp.h"
#include "mhs_user_event.h"

#ifdef __cplusplus
  extern "C" {
#endif

struct TCanDevicesList *LocalDeviceList;
struct TInfoVar *LocalHwInfo;

int32_t CALLBACK_TYPE CanExInitDriver(char *options);

int32_t CALLBACK_TYPE CanExCreateDevice(uint32_t *index, char *options);
int32_t CALLBACK_TYPE CanExDestroyDevice(uint32_t *index);

int32_t CALLBACK_TYPE CanExCreateFifo(uint32_t index, uint32_t size, TMhsEvent *event_obj, uint32_t event, uint32_t channels);
int32_t CALLBACK_TYPE CanExBindFifo(uint32_t fifo_index, uint32_t device_index, uint32_t bind);

TMhsEvent * CALLBACK_TYPE CanExCreateEvent(void);
int32_t CALLBACK_TYPE CanExSetObjEvent(uint32_t index, uint32_t source, TMhsEvent *event_obj, uint32_t event);
void CALLBACK_TYPE CanExSetEvent(TMhsEvent *event_obj, uint32_t event);
void CALLBACK_TYPE CanExSetEventAll(uint32_t event);  // <*> NEU
void CALLBACK_TYPE CanExResetEvent(TMhsEvent *event_obj, uint32_t event);
uint32_t CALLBACK_TYPE CanExWaitForEvent(TMhsEvent *event_obj, uint32_t timeout);

int32_t CALLBACK_TYPE CanExGetDeviceCount(int32_t flags);
int32_t CALLBACK_TYPE CanExGetDeviceList(struct TCanDevicesList **devices_list, int32_t flags);
int32_t CALLBACK_TYPE CanExGetDeviceListPerform(int32_t flags);
int32_t CALLBACK_TYPE CanExGetDeviceListGet(struct TCanDevicesList *item); 
int32_t CALLBACK_TYPE CanExGetDeviceInfo(uint32_t index, struct TCanDeviceInfo *device_info,
  struct TInfoVar **hw_info, uint32_t *hw_info_size);
int32_t CALLBACK_TYPE CanExGetDeviceInfoPerform(uint32_t index, struct TCanDeviceInfo *device_info);
int32_t CALLBACK_TYPE CanExGetDeviceInfoGet(struct TInfoVar *item);  
void CALLBACK_TYPE CanExDataFree(void **data);

int32_t CALLBACK_TYPE CanExSetOptions(uint32_t index, char *options);

int32_t CALLBACK_TYPE CanExSetAsByte(uint32_t index, char *name, char value);
int32_t CALLBACK_TYPE CanExSetAsWord(uint32_t index, char *name, int16_t value);
int32_t CALLBACK_TYPE CanExSetAsLong(uint32_t index, char *name, int32_t value);
int32_t CALLBACK_TYPE CanExSetAsUByte(uint32_t index, char *name, unsigned char value);
int32_t CALLBACK_TYPE CanExSetAsUWord(uint32_t index, char *name, uint16_t value);
int32_t CALLBACK_TYPE CanExSetAsULong(uint32_t index, char *name, uint32_t value);
int32_t CALLBACK_TYPE CanExSetAsString(uint32_t index, char *name, char *value);
int32_t CALLBACK_TYPE CanExGetAsByte(uint32_t index, char *name, char *value);
int32_t CALLBACK_TYPE CanExGetAsWord(uint32_t index, char *name, int16_t *value);
int32_t CALLBACK_TYPE CanExGetAsLong(uint32_t index, char *name, int32_t *value);
int32_t CALLBACK_TYPE CanExGetAsUByte(uint32_t index, char *name, unsigned char *value);
int32_t CALLBACK_TYPE CanExGetAsUWord(uint32_t index, char *name, uint16_t *value);
int32_t CALLBACK_TYPE CanExGetAsULong(uint32_t index, char *name, uint32_t *value);
int32_t CALLBACK_TYPE CanExGetAsString(uint32_t index, char *name, char **str);
int32_t CALLBACK_TYPE CanExGetAsStringCopy(uint32_t index, char *name, char *dest, uint32_t *dest_size);


#ifdef __cplusplus
  }
#endif

#endif
