#ifndef __SM_DRV_H__
#define __SM_DRV_H__

#include "global.h"
#include "tcan_drv.h"

#ifdef __cplusplus
  extern "C" {
#endif

#define ERR_SM_PORT_NOT_OPEN         -100
#define ERR_SM_TX_CMD                -101
#define ERR_SM_RX_ACK                -102
#define ERR_SM_TX_DATA               -103
#define ERR_SM_RX_DATA               -104


#define ERR_SM_RX_ACK_TIMEOUT        -1
#define ERR_SM_RX_PARAM_CNT          -2
#define ERR_SM_RX_PARAM_CNT_TIMEOUT  -3
#define ERR_SM_RX_PARAM              -4
#define ERR_SM_RX_PARAM_TIMEOUT      -5
#define ERR_SM_RX_PARAM_COUNT        -6
#define ERR_SM_RX_CRC                -7
#define ERR_SM_RX_CRC_TIMEOUT        -8
#define ERR_SM_WRONG_CRC             -9
#define ERR_SM_WRONG_ACK             -9

#define ERR_SM_NACK              1
#define ERR_SM_NACK_PARAM        2

int32_t SMDrvClear(TCanDevice *dev) ATTRIBUTE_INTERNAL;
int32_t SMDrvCommando(TCanDevice *dev, uint32_t sleep_time) ATTRIBUTE_INTERNAL;

#ifdef __cplusplus
  }
#endif

#endif
