#ifndef __TCAN_COM_H__
#define __TCAN_COM_H__

#include "global.h"
#include "tcan_drv.h"
#include "tar_drv.h"

#ifdef __cplusplus
  extern "C" {
#endif

#define COMM_MODE_SYNC        0
#define COMM_MODE_ASYNC       1

#define TAR_TOGGLE_FLAG       0x01

#define TAR_STREAM_STATUS     0x04
#define TAR_STREAM_TX_CHANNEL 0x08

#define TAR_STREAM_FILTER     0x20
#define TAR_STREAM_RXD        0x40
#define TAR_STREAM_CHANNEL    0x80

#define STATUS_READ_TIMEOUT 3000        // Status mindestens alle 3 Sekunden lesen

void SetTarStatusToDev(TCanDevice *dev, struct TTarStatus tar_status) ATTRIBUTE_INTERNAL;

int32_t ExtractCanMsg(struct TCanMsg *msg, unsigned char **src, int32_t *size, unsigned char mode) ATTRIBUTE_INTERNAL;
void TarComInit(int32_t comm_mode) ATTRIBUTE_INTERNAL;
int32_t MainCommProc(TCanDevice *dev) ATTRIBUTE_INTERNAL;

#ifdef __cplusplus
  }
#endif

#endif
