/*******************************************************************************/
/*                          Interface zur Tiny-CAN API                         */
/* --------------------------------------------------------------------------- */
/*  Beschreibung    : Laden einer Tiny-CAN API Treiber DLL                     */
/*                                                                             */
/*  Version         : 3.00                                                     */
/*  Datei Name      : mhs_can_drv.c                                            */
/* --------------------------------------------------------------------------- */
/*  Datum           : 11.10.2015                                               */
/*  Copyright       : (C) 2011 - 2015 by MHS-Elektronik GmbH & Co. KG, Germany */
/*                      www.mhs-elektronik.de                                  */
/*  Autor           : Demlehner Klaus, info@mhs-elektronik.de                  */
/*******************************************************************************/
#define CAN_DRV_INCLUDE

#include "can_drv.h"

#ifdef __WIN32__
  #include <string.h>
  #include <stdlib.h>
#else
  #include <stdio.h>
  #include <stdlib.h>
  #include <unistd.h>
  #include <dlfcn.h>
#endif


#ifdef CAN_API_TRUE_FUNC
static TCanInitDriver PCanInitDriver = NULL;
static TCanDownDriver PCanDownDriver = NULL;
static TCanSetOptions PCanSetOptions = NULL;
static TCanDeviceOpen PCanDeviceOpen = NULL;
static TCanDeviceClose PCanDeviceClose = NULL;
static TCanSetMode PCanSetMode = NULL;
static TCanTransmit PCanTransmit = NULL;
static TCanTransmitClear PCanTransmitClear = NULL;
static TCanTransmitGetCount PCanTransmitGetCount =  NULL;
static TCanTransmitSet PCanTransmitSet = NULL;
static TCanReceive PCanReceive = NULL;
static TCanReceiveClear PCanReceiveClear = NULL;
static TCanReceiveGetCount PCanReceiveGetCount = NULL;
static TCanSetSpeed PCanSetSpeed = NULL;
static TCanSetSpeedUser PCanSetSpeedUser = NULL;
static TCanDrvInfo PCanDrvInfo = NULL;
static TCanDrvHwInfo PCanDrvHwInfo = NULL;
static TCanSetFilter PCanSetFilter = NULL;
static TCanGetDeviceStatus PCanGetDeviceStatus = NULL;
static TCanSetPnPEventCallback PCanSetPnPEventCallback = NULL;
static TCanSetStatusEventCallback PCanSetStatusEventCallback = NULL;
static TCanSetRxEventCallback PCanSetRxEventCallback = NULL;
static TCanSetEvents PCanSetEvents = NULL;
static TCanEventStatus PCanEventStatus = NULL;
// EX-Funktionen
static TCanExGetDeviceCount PCanExGetDeviceCount = NULL;
static TCanExGetDeviceList PCanExGetDeviceList = NULL;
static TCanExGetDeviceListPerform PCanExGetDeviceListPerform = NULL;
static TCanExGetDeviceListGet PCanExGetDeviceListGet = NULL;
static TCanExGetDeviceInfo PCanExGetDeviceInfo = NULL;
static TCanExGetDeviceInfoPerform PCanExGetDeviceInfoPerform = NULL;
static TCanExGetDeviceInfoGet PCanExGetDeviceInfoGet = NULL;
static TCanExDataFree PCanExDataFree = NULL;
static TCanExCreateDevice PCanExCreateDevice = NULL;
static TCanExDestroyDevice PCanExDestroyDevice = NULL;
static TCanExCreateFifo PCanExCreateFifo = NULL;
static TCanExBindFifo PCanExBindFifo = NULL;
static TCanExCreateEvent PCanExCreateEvent = NULL;
static TCanExSetObjEvent PCanExSetObjEvent = NULL;
static TCanExSetEvent PCanExSetEvent = NULL;
static TCanExSetEventAll PCanExSetEventAll = NULL;
static TCanExResetEvent PCanExResetEvent = NULL;
static TCanExWaitForEvent PCanExWaitForEvent = NULL;
static TCanExInitDriver PCanExInitDriver = NULL;
static TCanExSetOptions PCanExSetOptions = NULL;
static TCanExSetAsByte PCanExSetAsByte = NULL;
static TCanExSetAsWord PCanExSetAsWord = NULL;
static TCanExSetAsLong PCanExSetAsLong = NULL;
static TCanExSetAsUByte PCanExSetAsUByte = NULL;
static TCanExSetAsUWord PCanExSetAsUWord = NULL;
static TCanExSetAsULong PCanExSetAsULong = NULL;
static TCanExSetAsString PCanExSetAsString = NULL;
static TCanExGetAsByte PCanExGetAsByte = NULL;
static TCanExGetAsWord PCanExGetAsWord = NULL;
static TCanExGetAsLong PCanExGetAsLong = NULL;
static TCanExGetAsUByte PCanExGetAsUByte = NULL;
static TCanExGetAsUWord PCanExGetAsUWord = NULL;
static TCanExGetAsULong PCanExGetAsULong = NULL;
static TCanExGetAsString PCanExGetAsString = NULL;
static TCanExGetAsStringCopy PCanExGetAsStringCopy = NULL;
#else
int32_t DRV_CALLBACK_TYPE DefCanInitDriver(char *options);
void DRV_CALLBACK_TYPE DefCanDownDriver(void);
int32_t DRV_CALLBACK_TYPE DefCanSetOptions(char *options);
int32_t DRV_CALLBACK_TYPE DefCanDeviceOpen(uint32_t  index, char *parameter);
int32_t DRV_CALLBACK_TYPE DefCanDeviceClose(uint32_t  index);

int32_t DRV_CALLBACK_TYPE DefCanSetMode(uint32_t  index, unsigned char can_op_mode, uint16_t  can_command);

int32_t DRV_CALLBACK_TYPE DefCanTransmit(uint32_t  index, struct TCanMsg *msg, int32_t count);
void DRV_CALLBACK_TYPE DefCanTransmitClear(uint32_t  index);
uint32_t  DRV_CALLBACK_TYPE DefCanTransmitGetCount(uint32_t  index);
int32_t DRV_CALLBACK_TYPE DefCanTransmitSet(uint32_t  index, uint16_t  cmd,
  uint32_t  time);
int32_t DRV_CALLBACK_TYPE DefCanReceive(uint32_t  index, struct TCanMsg *msg, int32_t count);
void DRV_CALLBACK_TYPE DefCanReceiveClear(uint32_t  index);
uint32_t  DRV_CALLBACK_TYPE DefCanReceiveGetCount(uint32_t  index);

int32_t DRV_CALLBACK_TYPE DefCanSetSpeed(uint32_t  index, uint16_t  speed);
int32_t DRV_CALLBACK_TYPE DefCanSetSpeedUser(uint32_t  index, uint32_t  value);
char * DRV_CALLBACK_TYPE DefCanDrvInfo(void);
char * DRV_CALLBACK_TYPE DefCanDrvHwInfo(uint32_t index);
int32_t DRV_CALLBACK_TYPE DefCanSetFilter(uint32_t index, struct TMsgFilter *msg_filter);
int32_t DRV_CALLBACK_TYPE DefCanGetDeviceStatus(uint32_t  index, struct TDeviceStatus *status);
void DRV_CALLBACK_TYPE DefCanSetPnPEventCallback(void (DRV_CALLBACK_TYPE *event)(uint32_t  index, int32_t status));
void DRV_CALLBACK_TYPE DefCanSetStatusEventCallback(void (DRV_CALLBACK_TYPE *event)
  (uint32_t  index, struct TDeviceStatus *device_status));
void DRV_CALLBACK_TYPE DefCanSetRxEventCallback(void (DRV_CALLBACK_TYPE *event)(uint32_t  index,
  struct TCanMsg *msg, int32_t count));

void DRV_CALLBACK_TYPE DefCanSetEvents(uint16_t  events);
uint32_t DRV_CALLBACK_TYPE DefCanEventStatus(void);

// EX-Funktionen
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceCount(int32_t flags);
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceList(struct TCanDevicesList **devices_list, int32_t flags);
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceListPerform(int32_t flags);
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceListGet(struct TCanDevicesList *item);
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceInfo(uint32_t index, struct TCanDeviceInfo *device_info,
  struct TCanInfoVar **hw_info, uint32_t *hw_info_size);
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceInfoPerform(uint32_t index, struct TCanDeviceInfo *device_info);
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceInfoGet(struct TCanInfoVar *item);
void DRV_CALLBACK_TYPE DefCanExDataFree(void **data);
int32_t DRV_CALLBACK_TYPE DefCanExCreateDevice(uint32_t *index, char *options);
int32_t DRV_CALLBACK_TYPE DefCanExDestroyDevice(uint32_t *index);
int32_t DRV_CALLBACK_TYPE DefCanExCreateFifo(uint32_t index, uint32_t size, TMhsEvent *event_obj, uint32_t event, uint32_t channels);
int32_t DRV_CALLBACK_TYPE DefCanExBindFifo(uint32_t fifo_index, uint32_t device_index, uint32_t bind);
TMhsEvent * DRV_CALLBACK_TYPE DefCanExCreateEvent(void);
int32_t DRV_DRV_CALLBACK_TYPE_TYPE DefCanExSetObjEvent(uint32_t index, uint32_t source, TMhsEvent *event_obj, uint32_t event);
void DRV_CALLBACK_TYPE DefCanExSetEvent(TMhsEvent *event_obj, uint32_t event);
void DRV_CALLBACK_TYPE DefCanExSetEventAll(uint32_t event);
void DRV_CALLBACK_TYPE DefCanExResetEvent(TMhsEvent *event_obj, uint32_t event);
uint32_t DRV_CALLBACK_TYPE DefCanExWaitForEvent(TMhsEvent *event_obj, uint32_t timeout);
int32_t DRV_CALLBACK_TYPE DefCanExInitDriver(char *options);
int32_t DRV_CALLBACK_TYPE DefCanExSetOptions(uint32_t index, char *options);
int32_t DRV_CALLBACK_TYPE DefCanExSetAsByte(uint32_t index, char *name, char value);
int32_t DRV_CALLBACK_TYPE DefCanExSetAsWord(uint32_t index, char *name, int16_t value);
int32_t DRV_CALLBACK_TYPE DefCanExSetAsLong(uint32_t index, char *name, int32_t value);
int32_t DRV_CALLBACK_TYPE DefCanExSetAsUByte(uint32_t index, char *name, unsigned char value);
int32_t DRV_CALLBACK_TYPE DefCanExSetAsUWord(uint32_t index, char *name, uint16_t value);
int32_t DRV_CALLBACK_TYPE DefCanExSetAsULong(uint32_t index, char *name, uint32_t value);
int32_t DRV_CALLBACK_TYPE DefCanExSetAsString(uint32_t index, char *name, char *value);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsByte(uint32_t index, char *name, char *value);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsWord(uint32_t index, char *name, int16_t *value);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsLong(uint32_t index, char *name, int32_t *value);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsUByte(uint32_t index, char *name, unsigned char *value);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsUWord(uint32_t index, char *name, uint16_t *value);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsULong(uint32_t index, char *name, uint32_t *value);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsString(uint32_t index, char *name, char **str);
int32_t DRV_CALLBACK_TYPE DefCanExGetAsStringCopy(uint32_t index, char *name, char *dest, uint32_t *dest_size);

TCanInitDriver CanInitDriver = DefCanInitDriver;
TCanDownDriver CanDownDriver = DefCanDownDriver;
TCanSetOptions CanSetOptions = DefCanSetOptions;
TCanDeviceOpen CanDeviceOpen = DefCanDeviceOpen;
TCanDeviceClose CanDeviceClose = DefCanDeviceClose;
TCanSetMode CanSetMode = DefCanSetMode;
TCanTransmit CanTransmit = DefCanTransmit;
TCanTransmitClear CanTransmitClear = DefCanTransmitClear;
TCanTransmitGetCount CanTransmitGetCount = DefCanTransmitGetCount;
TCanTransmitSet CanTransmitSet = DefCanTransmitSet;
TCanReceive CanReceive = DefCanReceive;
TCanReceiveClear CanReceiveClear = DefCanReceiveClear;
TCanReceiveGetCount CanReceiveGetCount = DefCanReceiveGetCount;
TCanSetSpeed CanSetSpeed = DefCanSetSpeed;
TCanSetSpeedUser CanSetSpeedUser = DefCanSetSpeedUser;
TCanDrvInfo CanDrvInfo = DefCanDrvInfo;
TCanDrvHwInfo CanDrvHwInfo = DefCanDrvHwInfo;
TCanSetFilter CanSetFilter = DefCanSetFilter;
TCanGetDeviceStatus CanGetDeviceStatus = DefCanGetDeviceStatus;
TCanSetPnPEventCallback CanSetPnPEventCallback = DefCanSetPnPEventCallback;
TCanSetStatusEventCallback CanSetStatusEventCallback = DefCanSetStatusEventCallback;
TCanSetRxEventCallback CanSetRxEventCallback = DefCanSetRxEventCallback;
TCanSetEvents CanSetEvents = DefCanSetEvents;
TCanEventStatus CanEventStatus = DefCanEventStatus;

// EX-Funktionen
TCanExGetDeviceCount CanExGetDeviceCount = DefCanExGetDeviceCount;
TCanExGetDeviceList CanExGetDeviceList = DefCanExGetDeviceList;
TCanExGetDeviceListPerform CanExGetDeviceListPerform = DefCanExGetDeviceListPerform;
TCanExGetDeviceListGet CanExGetDeviceListGet = DefCanExGetDeviceListGet;
TCanExGetDeviceInfo CanExGetDeviceInfo = DefCanExGetDeviceInfo;
TCanExGetDeviceInfoPerform CanExGetDeviceInfoPerform = DefCanExGetDeviceInfoPerform;
TCanExGetDeviceInfoGet CanExGetDeviceInfoGet = DefCanExGetDeviceInfoGet;
TCanExDataFree CanExDataFree = DefCanExDataFree;
TCanExCreateDevice CanExCreateDevice = DefCanExCreateDevice;
TCanExDestroyDevice CanExDestroyDevice = DefCanExDestroyDevice;
TCanExCreateFifo CanExCreateFifo = DefCanExCreateFifo;
TCanExBindFifo CanExBindFifo = DefCanExBindFifo;
TCanExCreateEvent CanExCreateEvent = DefCanExCreateEvent;
TCanExSetObjEvent CanExSetObjEvent = DefCanExSetObjEvent;
TCanExSetEvent CanExSetEvent = DefCanExSetEvent;
TCanExSetEventAll CanExSetEventAll = DefCanExSetEventAll;
TCanExResetEvent CanExResetEvent = DefCanExResetEvent;
TCanExWaitForEvent CanExWaitForEvent = DefCanExWaitForEvent;
TCanExInitDriver CanExInitDriver = DefCanExInitDriver;
TCanExSetOptions CanExSetOptions = DefCanExSetOptions;
TCanExSetAsByte CanExSetAsByte = DefCanExSetAsByte;
TCanExSetAsWord CanExSetAsWord = DefCanExSetAsWord;
TCanExSetAsLong CanExSetAsLong = DefCanExSetAsLong;
TCanExSetAsUByte CanExSetAsUByte = DefCanExSetAsUByte;
TCanExSetAsUWord CanExSetAsUWord = DefCanExSetAsUWord;
TCanExSetAsULong CanExSetAsULong = DefCanExSetAsULong;
TCanExSetAsString CanExSetAsString = DefCanExSetAsString;
TCanExGetAsByte CanExGetAsByte = DefCanExGetAsByte;
TCanExGetAsWord CanExGetAsWord = DefCanExGetAsWord;
TCanExGetAsLong CanExGetAsLong = DefCanExGetAsLong;
TCanExGetAsUByte CanExGetAsUByte = DefCanExGetAsUByte;
TCanExGetAsUWord CanExGetAsUWord = DefCanExGetAsUWord;
TCanExGetAsULong CanExGetAsULong = DefCanExGetAsULong;
TCanExGetAsString CanExGetAsString = DefCanExGetAsString;
TCanExGetAsStringCopy CanExGetAsStringCopy = DefCanExGetAsStringCopy;
#endif

#ifdef __WIN32__
static HINSTANCE DriverHandle = 0;               // Handle to DLL
static char *DriverFileName = NULL;

  #if _MSC_VER >= 1500
    #define INTERLOCK_TYPE_CONV
  #else
    #define INTERLOCK_TYPE_CONV (volatile LPLONG)
  #endif
#else
static void *DriverHandle = NULL;
#endif


#ifdef DRV_REF_LOCKING

  #ifdef __WIN32__
    // ****** Windows
static volatile LONG DrvRefCounter = 0;

    #define CAN_DRV_REF() (void)InterlockedIncrement(INTERLOCK_TYPE_CONV&DrvRefCounter)
    #define CAN_DRV_UNREF() (void)InterlockedDecrement(INTERLOCK_TYPE_CONV&DrvRefCounter)
  #else
    // ****** Linux
static volatile uint32_t DrvRefCounter = 0;
    #define CAN_DRV_REF() (void) __sync_fetch_and_add(&DrvRefCounter, 1)
    #define CAN_DRV_UNREF() (void) __sync_fetch_and_sub(&DrvRefCounter, 1)
  #endif
#else
  #define CAN_DRV_REF()
  #define CAN_DRV_UNREF()
#endif


#ifdef __WIN32__
  // ****** Windows
  #define mhs_sleep(x) Sleep(x)
  #define MhsGetProcAddress(h, s) GetProcAddress((h), (LPCSTR)(s))
#else
  // ****** Linux
  #define mhs_sleep(x) usleep((x) * 1000)
  #define MhsGetProcAddress(h, s) dlsym((h), (s))
#endif


#ifdef __WIN32__

#define MhsSafeFree(d) do { \
  if ((d)) \
    { \
    free((d)); \
    (d) = NULL; \
    } \
  } while(0)

static char *GetApiDriverWithPath(const char *driver_file);
#endif

/***************************************************************/
/*  Treiber DLL laden                                          */
/***************************************************************/
int32_t LoadDriver(const char *file_name)
{
int32_t error;

error = 0;
UnloadDriver();
#ifdef __WIN32__
if (!(DriverFileName = GetApiDriverWithPath(file_name)))
  return(-100);
DriverHandle = LoadLibraryA(DriverFileName);
#else
DriverHandle = dlopen(file_name, RTLD_LAZY);
#endif
if (DriverHandle)
  {
#ifdef CAN_API_TRUE_FUNC
  if  (!(PCanInitDriver = (TCanInitDriver)MhsGetProcAddress(DriverHandle, "CanInitDriver")))
    error = -1;
  else if (!(PCanDownDriver = (TCanDownDriver)MhsGetProcAddress(DriverHandle, "CanDownDriver")))
    error = -2;
  else if (!(PCanSetOptions = (TCanSetOptions)MhsGetProcAddress(DriverHandle, "CanSetOptions")))
    error = -3;
  else if (!(PCanDeviceOpen = (TCanDeviceOpen)MhsGetProcAddress(DriverHandle, "CanDeviceOpen")))
    error = -4;
  else if (!(PCanDeviceClose = (TCanDeviceClose)MhsGetProcAddress(DriverHandle, "CanDeviceClose")))
    error = -5;
  else if (!(PCanSetMode = (TCanSetMode)MhsGetProcAddress(DriverHandle, "CanSetMode")))
    error = -7;
  else if (!(PCanTransmit = (TCanTransmit)MhsGetProcAddress(DriverHandle, "CanTransmit")))
    error = -10;
  else if (!(PCanTransmitClear = (TCanTransmitClear)MhsGetProcAddress(DriverHandle, "CanTransmitClear")))
    error = -11;
  else if (!(PCanTransmitGetCount = (TCanTransmitGetCount)MhsGetProcAddress(DriverHandle, "CanTransmitGetCount")))
    error = -12;
  else if (!(PCanTransmitSet = (TCanTransmitSet)MhsGetProcAddress(DriverHandle, "CanTransmitSet")))
    error = -13;
  else if (!(PCanReceive = (TCanReceive)MhsGetProcAddress(DriverHandle, "CanReceive")))
    error = -14;
  else if (!(PCanReceiveClear = (TCanReceiveClear)MhsGetProcAddress(DriverHandle, "CanReceiveClear")))
    error = -15;
  else if (!(PCanReceiveGetCount = (TCanReceiveGetCount)MhsGetProcAddress(DriverHandle, "CanReceiveGetCount")))
    error = -16;
  else if (!(PCanSetSpeed = (TCanSetSpeed)MhsGetProcAddress(DriverHandle, "CanSetSpeed")))
    error = -17;
  else if (!(PCanSetSpeedUser = (TCanSetSpeedUser)MhsGetProcAddress(DriverHandle, "CanSetSpeedUser")))
    error = -18;
  else if (!(PCanDrvInfo = (TCanDrvInfo)MhsGetProcAddress(DriverHandle, "CanDrvInfo")))
    error = -19;
  else if (!(PCanDrvHwInfo = (TCanDrvHwInfo)MhsGetProcAddress(DriverHandle, "CanDrvHwInfo")))
    error = -20;
  else if (!(PCanSetFilter = (TCanSetFilter)MhsGetProcAddress(DriverHandle, "CanSetFilter")))
    error = -21;
  else if (!(PCanGetDeviceStatus = (TCanGetDeviceStatus)MhsGetProcAddress(DriverHandle, "CanGetDeviceStatus")))
    error = -22;
  else if (!(PCanSetPnPEventCallback = (TCanSetPnPEventCallback)MhsGetProcAddress(DriverHandle, "CanSetPnPEventCallback")))
    error = -23;
  else if (!(PCanSetStatusEventCallback = (TCanSetStatusEventCallback)MhsGetProcAddress(DriverHandle, "CanSetStatusEventCallback")))
    error = -24;
  else if (!(PCanSetRxEventCallback = (TCanSetRxEventCallback)MhsGetProcAddress(DriverHandle, "CanSetRxEventCallback")))
    error = -25;
  else if (!(PCanSetEvents = (TCanSetEvents)MhsGetProcAddress(DriverHandle, "CanSetEvents")))
    error = -26;
  else if (!(PCanEventStatus = (TCanEventStatus)MhsGetProcAddress(DriverHandle, "CanEventStatus")))
    error = -27;
  // EX-Funktionen
  else if (!(PCanExGetDeviceCount = (TCanExGetDeviceCount)MhsGetProcAddress(DriverHandle, "CanExGetDeviceCount")))
    error = -28;
  else if (!(PCanExGetDeviceList = (TCanExGetDeviceList)MhsGetProcAddress(DriverHandle, "CanExGetDeviceList")))
    error = -29;
  else if (!(PCanExGetDeviceListPerform = (TCanExGetDeviceListPerform)MhsGetProcAddress(DriverHandle, "CanExGetDeviceListPerform")))
    error = -57;
    else if (!(PCanExGetDeviceListGet = (TCanExGetDeviceListGet)MhsGetProcAddress(DriverHandle, "CanExGetDeviceListGet")))
    error = -58;
  else if (!(PCanExGetDeviceInfo = (TCanExGetDeviceInfo)MhsGetProcAddress(DriverHandle, "CanExGetDeviceInfo")))
    error = -30;
  else if (!(PCanExGetDeviceInfoPerform = (TCanExGetDeviceInfoPerform)MhsGetProcAddress(DriverHandle, "CanExGetDeviceInfoPerform")))
    error = -59;
  else if (!(PCanExGetDeviceInfoGet = (TCanExGetDeviceInfoGet)MhsGetProcAddress(DriverHandle, "CanExGetDeviceInfoGet")))
    error = -60;
  else if (!(PCanExDataFree = (TCanExDataFree)MhsGetProcAddress(DriverHandle, "CanExDataFree")))
    error = -31;
  else if (!(PCanExCreateDevice = (TCanExCreateDevice)MhsGetProcAddress(DriverHandle, "CanExCreateDevice")))
    error = -32;
  else if (!(PCanExDestroyDevice = (TCanExDestroyDevice)MhsGetProcAddress(DriverHandle, "CanExDestroyDevice")))
    error = -33;
  else if (!(PCanExCreateFifo = (TCanExCreateFifo)MhsGetProcAddress(DriverHandle, "CanExCreateFifo")))
    error = -34;
  else if (!(PCanExBindFifo = (TCanExBindFifo)MhsGetProcAddress(DriverHandle, "CanExBindFifo")))
    error = -35;
  else if (!(PCanExCreateEvent = (TCanExCreateEvent)MhsGetProcAddress(DriverHandle, "CanExCreateEvent")))
    error = -36;
  else if (!(PCanExSetObjEvent = (TCanExSetObjEvent)MhsGetProcAddress(DriverHandle, "CanExSetObjEvent")))
    error = -37;
  else if (!(PCanExSetEvent = (TCanExSetEvent)MhsGetProcAddress(DriverHandle, "CanExSetEvent")))
    error = -38;
  else if (!(PCanExResetEvent = (TCanExResetEvent)MhsGetProcAddress(DriverHandle, "CanExResetEvent")))
    error = -39;
  else if (!(PCanExWaitForEvent = (TCanExWaitForEvent)MhsGetProcAddress(DriverHandle, "CanExWaitForEvent")))
    error = -40;
  else if (!(PCanExInitDriver = (TCanExInitDriver)MhsGetProcAddress(DriverHandle, "CanExInitDriver")))
    error = -41;
  else if (!(PCanExSetOptions = (TCanExSetOptions)MhsGetProcAddress(DriverHandle, "CanExSetOptions")))
    error = -42;
  else if (!(PCanExSetAsByte = (TCanExSetAsByte)MhsGetProcAddress(DriverHandle, "CanExSetAsByte")))
    error = -43;
  else if (!(PCanExSetAsWord = (TCanExSetAsWord)MhsGetProcAddress(DriverHandle, "CanExSetAsWord")))
    error = -44;
  else if (!(PCanExSetAsLong = (TCanExSetAsLong)MhsGetProcAddress(DriverHandle, "CanExSetAsLong")))
    error = -45;
  else if (!(PCanExSetAsUByte = (TCanExSetAsUByte)MhsGetProcAddress(DriverHandle, "CanExSetAsUByte")))
    error = -46;
  else if (!(PCanExSetAsUWord = (TCanExSetAsUWord)MhsGetProcAddress(DriverHandle, "CanExSetAsUWord")))
    error = -47;
  else if (!(PCanExSetAsULong = (TCanExSetAsULong)MhsGetProcAddress(DriverHandle, "CanExSetAsULong")))
    error = -48;
  else if (!(PCanExSetAsString = (TCanExSetAsString)MhsGetProcAddress(DriverHandle, "CanExSetAsString")))
    error = -49;
  else if (!(PCanExGetAsByte = (TCanExGetAsByte)MhsGetProcAddress(DriverHandle, "CanExGetAsByte")))
    error = -50;
  else if (!(PCanExGetAsWord = (TCanExGetAsWord)MhsGetProcAddress(DriverHandle, "CanExGetAsWord")))
    error = -51;
  else if (!(PCanExGetAsLong = (TCanExGetAsLong)MhsGetProcAddress(DriverHandle, "CanExGetAsLong")))
    error = -52;
  else if (!(PCanExGetAsUByte = (TCanExGetAsUByte)MhsGetProcAddress(DriverHandle, "CanExGetAsUByte")))
    error = -53;
  else if (!(PCanExGetAsUWord = (TCanExGetAsUWord)MhsGetProcAddress(DriverHandle, "CanExGetAsUWord")))
    error = -54;
  else if (!(PCanExGetAsULong = (TCanExGetAsULong)MhsGetProcAddress(DriverHandle, "CanExGetAsULong")))
    error = -55;
  else if (!(PCanExGetAsString = (TCanExGetAsString)MhsGetProcAddress(DriverHandle, "CanExGetAsString")))
    error = -56;
  else if (!(PCanExGetAsStringCopy = (TCanExGetAsStringCopy)MhsGetProcAddress(DriverHandle, "CanExGetAsStringCopy")))
    error = -61;
  else if (!(PCanExSetEventAll = (TCanExSetEventAll)MhsGetProcAddress(DriverHandle, "CanExSetEventAll")))
    error = -62;
#else
  if  (!(CanInitDriver = (TCanInitDriver)MhsGetProcAddress(DriverHandle, "CanInitDriver")))
    error = -1;
  else if (!(CanDownDriver = (TCanDownDriver)MhsGetProcAddress(DriverHandle, "CanDownDriver")))
    error = -2;
  else if (!(CanSetOptions = (TCanSetOptions)MhsGetProcAddress(DriverHandle, "CanSetOptions")))
    error = -3;
  else if (!(CanDeviceOpen = (TCanDeviceOpen)MhsGetProcAddress(DriverHandle, "CanDeviceOpen")))
    error = -4;
  else if (!(CanDeviceClose = (TCanDeviceClose)MhsGetProcAddress(DriverHandle, "CanDeviceClose")))
    error = -5;
  else if (!(CanSetMode = (TCanSetMode)MhsGetProcAddress(DriverHandle, "CanSetMode")))
    error = -7;
  else if (!(CanTransmit = (TCanTransmit)MhsGetProcAddress(DriverHandle, "CanTransmit")))
    error = -10;
  else if (!(CanTransmitClear = (TCanTransmitClear)MhsGetProcAddress(DriverHandle, "CanTransmitClear")))
    error = -11;
  else if (!(CanTransmitGetCount = (TCanTransmitGetCount)MhsGetProcAddress(DriverHandle, "CanTransmitGetCount")))
    error = -12;
  else if (!(CanTransmitSet = (TCanTransmitSet)MhsGetProcAddress(DriverHandle, "CanTransmitSet")))
    error = -13;
  else if (!(CanReceive = (TCanReceive)MhsGetProcAddress(DriverHandle, "CanReceive")))
    error = -14;
  else if (!(CanReceiveClear = (TCanReceiveClear)MhsGetProcAddress(DriverHandle, "CanReceiveClear")))
    error = -15;
  else if (!(CanReceiveGetCount = (TCanReceiveGetCount)MhsGetProcAddress(DriverHandle, "CanReceiveGetCount")))
    error = -16;
  else if (!(CanSetSpeed = (TCanSetSpeed)MhsGetProcAddress(DriverHandle, "CanSetSpeed")))
    error = -17;
  else if (!(CanSetSpeedUser = (TCanSetSpeedUser)MhsGetProcAddress(DriverHandle, "CanSetSpeedUser")))
    error = -18;
  else if (!(CanDrvInfo = (TCanDrvInfo)MhsGetProcAddress(DriverHandle, "CanDrvInfo")))
    error = -19;
  else if (!(CanDrvHwInfo = (TCanDrvHwInfo)MhsGetProcAddress(DriverHandle, "CanDrvHwInfo")))
    error = -20;
  else if (!(CanSetFilter = (TCanSetFilter)MhsGetProcAddress(DriverHandle, "CanSetFilter")))
    error = -21;
  else if (!(CanGetDeviceStatus = (TCanGetDeviceStatus)MhsGetProcAddress(DriverHandle, "CanGetDeviceStatus")))
    error = -22;
  else if (!(CanSetPnPEventCallback = (TCanSetPnPEventCallback)MhsGetProcAddress(DriverHandle, "CanSetPnPEventCallback")))
    error = -23;
  else if (!(CanSetStatusEventCallback = (TCanSetStatusEventCallback)MhsGetProcAddress(DriverHandle, "CanSetStatusEventCallback")))
    error = -24;
  else if (!(CanSetRxEventCallback = (TCanSetRxEventCallback)MhsGetProcAddress(DriverHandle, "CanSetRxEventCallback")))
    error = -25;
  else if (!(CanSetEvents = (TCanSetEvents)MhsGetProcAddress(DriverHandle, "CanSetEvents")))
    error = -26;
  else if (!(CanEventStatus = (TCanEventStatus)MhsGetProcAddress(DriverHandle, "CanEventStatus")))
    error = -27;
  // EX-Funktionen
  else if (!(CanExGetDeviceCount = (TCanExGetDeviceCount)MhsGetProcAddress(DriverHandle, "CanExGetDeviceCount")))
    error = -28;
  else if (!(CanExGetDeviceList = (TCanExGetDeviceList)MhsGetProcAddress(DriverHandle, "CanExGetDeviceList")))
    error = -29;
  else if (!(CanExGetDeviceListPerform = (TCanExGetDeviceListPerform)MhsGetProcAddress(DriverHandle, "CanExGetDeviceListPerform")))
    error = -57;
  else if (!(CanExGetDeviceListGet = (TCanExGetDeviceListGet)MhsGetProcAddress(DriverHandle, "CanExGetDeviceListGet")))
    error = -58;
  else if (!(CanExGetDeviceInfo = (TCanExGetDeviceInfo)MhsGetProcAddress(DriverHandle, "CanExGetDeviceInfo")))
    error = -30;
  else if (!(CanExGetDeviceInfoPerform = (TCanExGetDeviceInfoPerform)MhsGetProcAddress(DriverHandle, "CanExGetDeviceInfoPerform")))
    error = -59;
  else if (!(CanExGetDeviceInfoGet = (TCanExGetDeviceInfoGet)MhsGetProcAddress(DriverHandle, "CanExGetDeviceInfoGet")))
    error = -60;
  else if (!(CanExDataFree = (TCanExDataFree)MhsGetProcAddress(DriverHandle, "CanExDataFree")))
    error = -31;
  else if (!(CanExCreateDevice = (TCanExCreateDevice)MhsGetProcAddress(DriverHandle, "CanExCreateDevice")))
    error = -32;
  else if (!(CanExDestroyDevice = (TCanExDestroyDevice)MhsGetProcAddress(DriverHandle, "CanExDestroyDevice")))
    error = -33;
  else if (!(CanExCreateFifo = (TCanExCreateFifo)MhsGetProcAddress(DriverHandle, "CanExCreateFifo")))
    error = -34;
  else if (!(CanExBindFifo = (TCanExBindFifo)MhsGetProcAddress(DriverHandle, "CanExBindFifo")))
    error = -35;
  else if (!(CanExCreateEvent = (TCanExCreateEvent)MhsGetProcAddress(DriverHandle, "CanExCreateEvent")))
    error = -36;
  else if (!(CanExSetObjEvent = (TCanExSetObjEvent)MhsGetProcAddress(DriverHandle, "CanExSetObjEvent")))
    error = -37;
  else if (!(CanExSetEvent = (TCanExSetEvent)MhsGetProcAddress(DriverHandle, "CanExSetEvent")))
    error = -38;
  else if (!(CanExResetEvent = (TCanExResetEvent)MhsGetProcAddress(DriverHandle, "CanExResetEvent")))
    error = -39;
  else if (!(CanExWaitForEvent = (TCanExWaitForEvent)MhsGetProcAddress(DriverHandle, "CanExWaitForEvent")))
    error = -40;
  else if (!(CanExInitDriver = (TCanExInitDriver)MhsGetProcAddress(DriverHandle, "CanExInitDriver")))
    error = -41;
  else if (!(CanExSetOptions = (TCanExSetOptions)MhsGetProcAddress(DriverHandle, "CanExSetOptions")))
    error = -42;
  else if (!(CanExSetAsByte = (TCanExSetAsByte)MhsGetProcAddress(DriverHandle, "CanExSetAsByte")))
    error = -43;
  else if (!(CanExSetAsWord = (TCanExSetAsWord)MhsGetProcAddress(DriverHandle, "CanExSetAsWord")))
    error = -44;
  else if (!(CanExSetAsLong = (TCanExSetAsLong)MhsGetProcAddress(DriverHandle, "CanExSetAsLong")))
    error = -45;
  else if (!(CanExSetAsUByte = (TCanExSetAsUByte)MhsGetProcAddress(DriverHandle, "CanExSetAsUByte")))
    error = -46;
  else if (!(CanExSetAsUWord = (TCanExSetAsUWord)MhsGetProcAddress(DriverHandle, "CanExSetAsUWord")))
    error = -47;
  else if (!(CanExSetAsULong = (TCanExSetAsULong)MhsGetProcAddress(DriverHandle, "CanExSetAsULong")))
    error = -48;
  else if (!(CanExSetAsString = (TCanExSetAsString)MhsGetProcAddress(DriverHandle, "CanExSetAsString")))
    error = -49;
  else if (!(CanExGetAsByte = (TCanExGetAsByte)MhsGetProcAddress(DriverHandle, "CanExGetAsByte")))
    error = -50;
  else if (!(CanExGetAsWord = (TCanExGetAsWord)MhsGetProcAddress(DriverHandle, "CanExGetAsWord")))
    error = -51;
  else if (!(CanExGetAsLong = (TCanExGetAsLong)MhsGetProcAddress(DriverHandle, "CanExGetAsLong")))
    error = -52;
  else if (!(CanExGetAsUByte = (TCanExGetAsUByte)MhsGetProcAddress(DriverHandle, "CanExGetAsUByte")))
    error = -53;
  else if (!(CanExGetAsUWord = (TCanExGetAsUWord)MhsGetProcAddress(DriverHandle, "CanExGetAsUWord")))
    error = -54;
  else if (!(CanExGetAsULong = (TCanExGetAsULong)MhsGetProcAddress(DriverHandle, "CanExGetAsULong")))
    error = -55;
  else if (!(CanExGetAsString = (TCanExGetAsString)MhsGetProcAddress(DriverHandle, "CanExGetAsString")))
    error = -56;
  else if (!(CanExGetAsStringCopy = (TCanExGetAsStringCopy)MhsGetProcAddress(DriverHandle, "CanExGetAsStringCopy")))
    error = -61;
  else if (!(CanExSetEventAll = (TCanExSetEventAll)MhsGetProcAddress(DriverHandle, "CanExSetEventAll")))
    error = -62;
#endif
  }
else
  error = -100;
if (error)
  UnloadDriver();
return(error);
}


/***************************************************************/
/*  Treiber DLL entladen                                       */
/***************************************************************/
void UnloadDriver(void)
{
#ifdef __WIN32__
HINSTANCE driver_handle;
#else
void *driver_handle;
#endif

driver_handle = DriverHandle;
DriverHandle = NULL;
#ifdef __WIN32__
MhsSafeFree(DriverFileName);
#endif
if (driver_handle)
  CanDownDriver();
#ifdef CAN_API_TRUE_FUNC
PCanInitDriver = NULL;
PCanDownDriver = NULL;
PCanSetOptions = NULL;
PCanDeviceOpen = NULL;
PCanDeviceClose = NULL;
PCanSetMode = NULL;
PCanTransmit = NULL;
PCanTransmitClear = NULL;
PCanTransmitGetCount = NULL;
PCanTransmitSet = NULL;
PCanReceive = NULL;
PCanReceiveClear = NULL;
PCanReceiveGetCount = NULL;
PCanSetSpeed = NULL;
PCanSetSpeedUser = NULL;
PCanDrvInfo = NULL;
PCanDrvHwInfo = NULL;
PCanSetFilter = NULL;
PCanGetDeviceStatus = NULL;
PCanSetPnPEventCallback = NULL;
PCanSetStatusEventCallback = NULL;
PCanSetRxEventCallback = NULL;
PCanSetEvents = NULL;
PCanEventStatus = NULL;
// EX-Funktionen
PCanExGetDeviceCount = NULL;
PCanExGetDeviceList = NULL;
PCanExGetDeviceListPerform = NULL;
PCanExGetDeviceListGet = NULL;
PCanExGetDeviceInfo = NULL;
PCanExGetDeviceInfoPerform = NULL;
PCanExGetDeviceInfoGet = NULL;
PCanExDataFree = NULL;
PCanExCreateDevice = NULL;
PCanExDestroyDevice = NULL;
PCanExCreateFifo = NULL;
PCanExBindFifo = NULL;
PCanExCreateEvent = NULL;
PCanExSetObjEvent = NULL;
PCanExSetEvent = NULL;
PCanExSetEventAll = NULL;
PCanExResetEvent = NULL;
PCanExWaitForEvent = NULL;
PCanExInitDriver = NULL;
PCanExSetOptions = NULL;
PCanExSetAsByte = NULL;
PCanExSetAsWord = NULL;
PCanExSetAsLong = NULL;
PCanExSetAsUByte = NULL;
PCanExSetAsUWord = NULL;
PCanExSetAsULong = NULL;
PCanExSetAsString = NULL;
PCanExGetAsByte = NULL;
PCanExGetAsWord = NULL;
PCanExGetAsLong = NULL;
PCanExGetAsUByte = NULL;
PCanExGetAsUWord = NULL;
PCanExGetAsULong = NULL;
PCanExGetAsString = NULL;
PCanExGetAsStringCopy = NULL;
#else
CanInitDriver = DefCanInitDriver;
CanDownDriver = DefCanDownDriver;
CanSetOptions = DefCanSetOptions;
CanDeviceOpen = DefCanDeviceOpen;
CanDeviceClose = DefCanDeviceClose;
CanSetMode = DefCanSetMode;
CanTransmit = DefCanTransmit;
CanTransmitClear = DefCanTransmitClear;
CanTransmitGetCount = DefCanTransmitGetCount;
CanTransmitSet = DefCanTransmitSet;
CanReceive = DefCanReceive;
CanReceiveClear = DefCanReceiveClear;
CanReceiveGetCount = DefCanReceiveGetCount;
CanSetSpeed = DefCanSetSpeed;
CanSetSpeedUser = DefCanSetSpeedUser;
CanDrvInfo = DefCanDrvInfo;
CanDrvHwInfo = DefCanDrvHwInfo;
CanSetFilter = DefCanSetFilter;
CanGetDeviceStatus = DefCanGetDeviceStatus;
CanSetPnPEventCallback = DefCanSetPnPEventCallback;
CanSetStatusEventCallback = DefCanSetStatusEventCallback;
CanSetRxEventCallback = DefCanSetRxEventCallback;
CanSetEvents = DefCanSetEvents;
CanEventStatus = DefCanEventStatus;
// EX-Funktionen
CanExGetDeviceCount = DefCanExGetDeviceCount;
CanExGetDeviceList = DefCanExGetDeviceList;
CanExGetDeviceListPerform = DefCanExGetDeviceListPerform;
CanExGetDeviceListGet = DefCanExGetDeviceListGet;
CanExGetDeviceInfo = DefCanExGetDeviceInfo;
CanExGetDeviceInfoPerform = DefCanExGetDeviceInfoPerform;
CanExGetDeviceInfoGet = DefCanExGetDeviceInfoGet;
CanExDataFree = DefCanExDataFree;
CanExCreateDevice = DefCanExCreateDevice;
CanExDestroyDevice = DefCanExDestroyDevice;
CanExCreateFifo = DefCanExCreateFifo;
CanExBindFifo = DefCanExBindFifo;
CanExCreateEvent = DefCanExCreateEvent;
CanExSetObjEvent = DefCanExSetObjEvent;
CanExSetEvent = DefCanExSetEvent;
CanExSetEventAll = DefCanExSetEventAll;
CanExResetEvent = DefCanExResetEvent;
CanExWaitForEvent = DefCanExWaitForEvent;
CanExInitDriver = DefCanExInitDriver;
CanExSetOptions = DefCanExSetOptions;
CanExSetAsByte = DefCanExSetAsByte;
CanExSetAsWord = DefCanExSetAsWord;
CanExSetAsLong = DefCanExSetAsLong;
CanExSetAsUByte = DefCanExSetAsUByte;
CanExSetAsUWord = DefCanExSetAsUWord;
CanExSetAsULong = DefCanExSetAsULong;
CanExSetAsString = DefCanExSetAsString;
CanExGetAsByte = DefCanExGetAsByte;
CanExGetAsWord = DefCanExGetAsWord;
CanExGetAsLong = DefCanExGetAsLong;
CanExGetAsUByte = DefCanExGetAsUByte;
CanExGetAsUWord = DefCanExGetAsUWord;
CanExGetAsULong = DefCanExGetAsULong;
CanExGetAsString = DefCanExGetAsString;
CanExGetAsStringCopy = DefCanExGetAsStringCopy;
#endif
if (driver_handle)
  {
#ifdef __WIN32__
  FreeLibrary(driver_handle);
#else
  dlclose(driver_handle);
#endif
  }
}


#ifdef CAN_API_TRUE_FUNC

/***************************************************************/
/*  API Funktionen                                             */
/***************************************************************/
int32_t CanInitDriver(char *options)
{
if (PCanInitDriver)
  return((PCanInitDriver)(options));
else
  return(ERR_NO_CAN_DRIVER_LOAD);
}


void CanDownDriver(void)
{
#ifdef DRV_REF_LOCKING
uint32_t cnt, i;
#endif

if (PCanDownDriver)
  {
  // **** Alle Events sperren
  if (PCanSetEvents)      // CanSetEvents(0);
    (PCanSetEvents)(0);
  if (PCanExSetEventAll)  // CanExSetEventAll(MHS_TERMINATE);
    (PCanExSetEventAll)(MHS_TERMINATE);
#ifdef DRV_REF_LOCKING
  for (i = 5; i; i--)
    {
    cnt = 100;
    while (DrvRefCounter)
      {
      mhs_sleep(25);
      if (!--cnt)
        break;
      }
    mhs_sleep(1);
    if (!DrvRefCounter)
      break;
    }
  DrvRefCounter = 0;
#endif
  (PCanDownDriver)();
  }
}


int32_t CanSetOptions(char *options)
{
int32_t err;

if ((DriverHandle) && (PCanSetOptions))
  {
  CAN_DRV_REF();
  err = (PCanSetOptions)(options);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanDeviceOpen(uint32_t  index, char *parameter)
{
int32_t err;

if ((DriverHandle) && (PCanDeviceOpen))
  {
  CAN_DRV_REF();
  err = (PCanDeviceOpen)(index, parameter);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanDeviceClose(uint32_t  index)
{
int32_t err;

if ((DriverHandle) && (PCanDeviceClose))
  {
  CAN_DRV_REF();
  err = (PCanDeviceClose)(index);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanSetMode(uint32_t index, unsigned char can_op_mode, uint16_t can_command)
{
int32_t err;

if ((DriverHandle) && (PCanSetMode))
  {
  CAN_DRV_REF();
  err = (PCanSetMode)(index, can_op_mode, can_command);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanTransmit(uint32_t index, struct TCanMsg *msg, int32_t count)
{
int32_t err;

if ((DriverHandle) && (PCanTransmit))
  {
  CAN_DRV_REF();
  err = (PCanTransmit)(index, msg, count);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


void CanTransmitClear(uint32_t index)
{
if ((DriverHandle) && (PCanTransmitClear))
  {
  CAN_DRV_REF();
  (PCanTransmitClear)(index);
  CAN_DRV_UNREF();
  }
}


uint32_t CanTransmitGetCount(uint32_t index)
{
int32_t res;

res = 0;
if ((DriverHandle) && (PCanTransmitGetCount))
  {
  CAN_DRV_REF();
  res = (PCanTransmitGetCount)(index);
  CAN_DRV_UNREF();
  }
return(res);
}


int32_t CanTransmitSet(uint32_t index, uint16_t cmd, uint32_t time)
{
int32_t err;

if ((DriverHandle) && (PCanTransmitSet))
  {
  CAN_DRV_REF();
  err = (PCanTransmitSet)(index, cmd, time);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanReceive(uint32_t index, struct TCanMsg *msg, int32_t count)
{
int32_t err;

if ((DriverHandle) && (PCanReceive))
  {
  CAN_DRV_REF();
  err = (PCanReceive)(index, msg, count);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


void CanReceiveClear(uint32_t index)
{
if ((DriverHandle) && (PCanReceiveClear))
  {
  CAN_DRV_REF();
  (PCanReceiveClear)(index);
  CAN_DRV_UNREF();
  }
}


uint32_t CanReceiveGetCount(uint32_t index)
{
uint32_t res;

res = 0;
if ((DriverHandle) && (PCanReceiveGetCount))
  {
  CAN_DRV_REF();
  res = (PCanReceiveGetCount)(index);
  CAN_DRV_UNREF();
  }
return(res);
}


int32_t CanSetSpeed(uint32_t index, uint16_t speed)
{
int32_t err;

if ((DriverHandle) && (PCanSetSpeed))
  {
  CAN_DRV_REF();
  err = (PCanSetSpeed)(index, speed);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanSetSpeedUser(uint32_t index, uint32_t value)
{
int32_t err;

if ((DriverHandle) && (PCanSetSpeedUser))
  {
  CAN_DRV_REF();
  err = (PCanSetSpeedUser)(index, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


char *CanDrvInfo(void)
{
char *res;

res = NULL;
if ((DriverHandle) && (PCanDrvInfo))
  {
  CAN_DRV_REF();
  res = (PCanDrvInfo)();
  CAN_DRV_UNREF();
  }
return(res);
}


char *CanDrvHwInfo(uint32_t index)
{
char *res;

res = NULL;
if ((DriverHandle) && (PCanDrvHwInfo))
  {
  CAN_DRV_REF();
  res = (PCanDrvHwInfo)(index);
  CAN_DRV_UNREF();
  }
return(res);
}


int32_t CanSetFilter(uint32_t index, struct TMsgFilter *msg_filter)
{
int32_t err;

if ((DriverHandle) && (PCanSetFilter))
  {
  CAN_DRV_REF();
  err = (PCanSetFilter)(index, msg_filter);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanGetDeviceStatus(uint32_t index, struct TDeviceStatus *status)
{
int32_t err;

err = 0;
if ((DriverHandle) && (PCanGetDeviceStatus))
  {
  CAN_DRV_REF();
  err = (PCanGetDeviceStatus)(index, status);
  CAN_DRV_UNREF();
  }
else
  {
  if (status)
    {
    status->CanStatus = CAN_STATUS_UNBEKANNT;
    status->FifoStatus = FIFO_STATUS_UNBEKANNT;
    status->DrvStatus = DRV_NOT_LOAD;
    }
  }
return(err);
}


void CanSetPnPEventCallback(void (DRV_CALLBACK_TYPE *event)(uint32_t index, int32_t status))
{
if ((DriverHandle) && (PCanSetPnPEventCallback))
  {
  CAN_DRV_REF();
  (PCanSetPnPEventCallback)(event);
  CAN_DRV_UNREF();
  }
}


void CanSetStatusEventCallback(void (DRV_CALLBACK_TYPE *event)
  (uint32_t index, struct TDeviceStatus *device_status))
{
if ((DriverHandle) && (PCanSetStatusEventCallback))
  {
  CAN_DRV_REF();
  (PCanSetStatusEventCallback)(event);
  CAN_DRV_UNREF();
  }
}


void CanSetRxEventCallback(void (DRV_CALLBACK_TYPE *event)(uint32_t index,
  struct TCanMsg *msg, int32_t count))
{
if ((DriverHandle) && (PCanSetRxEventCallback))
  {
  CAN_DRV_REF();
  (PCanSetRxEventCallback)(event);
  CAN_DRV_UNREF();
  }
}


void CanSetEvents(uint16_t  events)
{
if ((DriverHandle) && (PCanSetEvents))
  {
  CAN_DRV_REF();
  (PCanSetEvents)(events);
  CAN_DRV_UNREF();
  }
}


uint32_t CanEventStatus(void)
{
int32_t err;

if ((DriverHandle) && (PCanEventStatus))
  {
  CAN_DRV_REF();
  err = (PCanEventStatus)();
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


// EX-Funktionen
int32_t CanExGetDeviceCount(int32_t flags)
{
int32_t err;

if ((DriverHandle) && (PCanExGetDeviceCount))
  {
  CAN_DRV_REF();
  err = (PCanExGetDeviceCount)(flags);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetDeviceList(struct TCanDevicesList **devices_list, int32_t flags)
{
int32_t err;

if ((DriverHandle) && (PCanExGetDeviceList))
  {
  CAN_DRV_REF();
  err = (PCanExGetDeviceList)(devices_list, flags);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetDeviceListPerform(int32_t flags)
{
int32_t err;

if ((DriverHandle) && (PCanExGetDeviceListPerform))
  {
  CAN_DRV_REF();
  err = (PCanExGetDeviceListPerform)(flags);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetDeviceListGet(struct TCanDevicesList *item)
{
int32_t err;

if ((DriverHandle) && (PCanExGetDeviceListGet))
  {
  CAN_DRV_REF();
  err = (PCanExGetDeviceListGet)(item);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetDeviceInfo(uint32_t index, struct TCanDeviceInfo *device_info,
  struct TCanInfoVar **hw_info, uint32_t *hw_info_size)
{
int32_t err;

if ((DriverHandle) && (PCanExGetDeviceInfo))
  {
  CAN_DRV_REF();
  err = (PCanExGetDeviceInfo)(index, device_info, hw_info, hw_info_size);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetDeviceInfoPerform(uint32_t index, struct TCanDeviceInfo *device_info)
{
int32_t err;

if ((DriverHandle) && (PCanExGetDeviceInfoPerform))
  {
  CAN_DRV_REF();
  err = (PCanExGetDeviceInfoPerform)(index, device_info);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetDeviceInfoGet(struct TCanInfoVar *item)
{
int32_t err;

if ((DriverHandle) && (PCanExGetDeviceInfoGet))
  {
  CAN_DRV_REF();
  err = (PCanExGetDeviceInfoGet)(item);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


void CanExDataFree(void **data)
{
if ((DriverHandle) && (PCanExDataFree))
  {
  CAN_DRV_REF();
  (PCanExDataFree)(data);
  CAN_DRV_UNREF();
  }
}


int32_t CanExCreateDevice(uint32_t *index, char *options)
{
int32_t err;

if ((DriverHandle) && (PCanExCreateDevice))
  {
  CAN_DRV_REF();
  err = (PCanExCreateDevice)(index, options);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExDestroyDevice(uint32_t *index)
{
int32_t err;

if ((DriverHandle) && (PCanExDestroyDevice))
  {
  CAN_DRV_REF();
  err = (PCanExDestroyDevice)(index);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExCreateFifo(uint32_t index, uint32_t size, TMhsEvent *event_obj, uint32_t event, uint32_t channels)
{
int32_t err;

if ((DriverHandle) && (PCanExCreateFifo))
  {
  CAN_DRV_REF();
  err = (PCanExCreateFifo)(index, size, event_obj, event, channels);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExBindFifo(uint32_t fifo_index, uint32_t device_index, uint32_t bind)
{
int32_t err;

if ((DriverHandle) && (PCanExBindFifo))
  {
  CAN_DRV_REF();
  err = (PCanExBindFifo)(fifo_index, device_index, bind);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


TMhsEvent *CanExCreateEvent(void)
{
TMhsEvent *event;

event = NULL;
if ((DriverHandle) && (PCanExCreateEvent))
  {
  CAN_DRV_REF();
  event = (PCanExCreateEvent)();
  CAN_DRV_UNREF();
  }
return(event);
}


int32_t CanExSetObjEvent(uint32_t index, uint32_t source, TMhsEvent *event_obj, uint32_t event)
{
int32_t err;

if ((DriverHandle) && (PCanExSetObjEvent))
  {
  CAN_DRV_REF();
  err = (PCanExSetObjEvent)(index, source, event_obj, event);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


void CanExSetEvent(TMhsEvent *event_obj, uint32_t event)
{
if ((DriverHandle) && (PCanExSetEvent))
  {
  CAN_DRV_REF();
  (PCanExSetEvent)(event_obj, event);
  CAN_DRV_UNREF();
  }
}


void CanExSetEventAll(uint32_t event)
{
if ((DriverHandle) && (PCanExSetEventAll))
  {
  CAN_DRV_REF();
  (PCanExSetEventAll)(event);
  CAN_DRV_UNREF();
  }
}


void CanExResetEvent(TMhsEvent *event_obj, uint32_t event)
{
if ((DriverHandle) && (PCanExResetEvent))
  {
  CAN_DRV_REF();
  (PCanExResetEvent)(event_obj, event);
  CAN_DRV_UNREF();
  }
}


uint32_t CanExWaitForEvent(TMhsEvent *event_obj, uint32_t timeout)
{
uint32_t res;

res = MHS_TERMINATE;
if ((DriverHandle) && (PCanExWaitForEvent))
  {
  CAN_DRV_REF();
  res = (PCanExWaitForEvent)(event_obj, timeout);
  CAN_DRV_UNREF();
  }
return(res);
}


int32_t CanExInitDriver(char *options)
{
if ((DriverHandle) && (PCanExInitDriver))
  return((PCanExInitDriver)(options));
else
  return(ERR_NO_CAN_DRIVER_LOAD);
}


int32_t CanExSetOptions(uint32_t index, char *options)
{
int32_t err;

if ((DriverHandle) && (PCanExSetOptions))
  {
  CAN_DRV_REF();
  err = (PCanExSetOptions)(index, options);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExSetAsByte(uint32_t index, char *name, char value)
{
int32_t err;

if ((DriverHandle) && (PCanExSetAsByte))
  {
  CAN_DRV_REF();
  err = (PCanExSetAsByte)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExSetAsWord(uint32_t index, char *name, int16_t value)
{
int32_t err;

if ((DriverHandle) && (PCanExSetAsWord))
  {
  CAN_DRV_REF();
  err = (PCanExSetAsWord)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExSetAsLong(uint32_t index, char *name, int32_t value)
{
int32_t err;

if ((DriverHandle) && (PCanExSetAsLong))
  {
  CAN_DRV_REF();
  err = (PCanExSetAsLong)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExSetAsUByte(uint32_t index, char *name, unsigned char value)
{
int32_t err;

if ((DriverHandle) && (PCanExSetAsUByte))
  {
  CAN_DRV_REF();
  err = (PCanExSetAsUByte)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExSetAsUWord(uint32_t index, char *name, uint16_t value)
{
int32_t err;

if ((DriverHandle) && (PCanExSetAsUWord))
  {
  CAN_DRV_REF();
  err = (PCanExSetAsUWord)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExSetAsULong(uint32_t index, char *name, uint32_t value)
{
int32_t err;

if ((DriverHandle) && (PCanExSetAsULong))
  {
  CAN_DRV_REF();
  err = (PCanExSetAsULong)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExSetAsString(uint32_t index, char *name, char *value)
{
int32_t err;

if ((DriverHandle) && (PCanExSetAsString))
  {
  CAN_DRV_REF();
  err = (PCanExSetAsString)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsByte(uint32_t index, char *name, char *value)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsByte))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsByte)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsWord(uint32_t index, char *name, int16_t *value)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsWord))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsWord)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsLong(uint32_t index, char *name, int32_t *value)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsLong))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsLong)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsUByte(uint32_t index, char *name, unsigned char *value)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsUByte))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsUByte)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsUWord(uint32_t index, char *name, uint16_t *value)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsUWord))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsUWord)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsULong(uint32_t index, char *name, uint32_t *value)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsULong))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsULong)(index, name, value);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsString(uint32_t index, char *name, char **str)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsString))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsString)(index, name, str);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}


int32_t CanExGetAsStringCopy(uint32_t index, char *name, char *dest, uint32_t *dest_size)
{
int32_t err;

if ((DriverHandle) && (PCanExGetAsStringCopy))
  {
  CAN_DRV_REF();
  err = (PCanExGetAsStringCopy)(index, name, dest, dest_size);
  CAN_DRV_UNREF();
  }
else
  err = ERR_NO_CAN_DRIVER_LOAD;
return(err);
}

#else

/***************************************************************/
/*  Default Call                                               */
/***************************************************************/
void DefDriverProcedure(int32_t func)
{
(void)func;
}


/***************************************************************/
/*  Default Funktionen                                         */
/***************************************************************/
int32_t DRV_CALLBACK_TYPE DefCanInitDriver(char *options)
{
(void)options;

DefDriverProcedure(1);
return(0);
}


void DRV_CALLBACK_TYPE DefCanDownDriver(void)
{
// DefDriverProcedure(1);
}


int32_t DRV_CALLBACK_TYPE DefCanSetOptions(char *options)
{
(void)options;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanDeviceOpen(uint32_t  index, char *parameter)
{
(void)index;
(void)parameter;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanDeviceClose(uint32_t  index)
{
(void)index;

return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanSetMode(uint32_t index, unsigned char can_op_mode, uint16_t can_command)
{
(void)index;
(void)can_op_mode;
(void)can_command;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanSet(uint32_t index, uint16_t obj_index, uint16_t obj_sub_index, void *data, int32_t size)
{
(void)index;
(void)obj_index;
(void)obj_sub_index;
(void)data;
(void)size;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanGet(uint32_t index, uint16_t obj_index, uint16_t obj_sub_index, void *data, int32_t size)
{
(void)index;
(void)obj_index;
(void)obj_sub_index;
(void)data;
(void)size;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanTransmit(uint32_t index, struct TCanMsg *msg, int32_t count)
{
(void)index;
(void)msg;
(void)count;

DefDriverProcedure(1);
return(0);
}


void DRV_CALLBACK_TYPE DefCanTransmitClear(uint32_t index)
{
(void)index;

DefDriverProcedure(1);
}


uint32_t  DRV_CALLBACK_TYPE DefCanTransmitGetCount(uint32_t index)
{
(void)index;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanTransmitSet(uint32_t index, uint16_t cmd, uint32_t time)
{
(void)index;
(void)cmd;
(void)time;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanReceive(uint32_t index, struct TCanMsg *msg, int32_t count)
{
(void)index;
(void)msg;
(void)count;

DefDriverProcedure(1);
return(0);
}


void DRV_CALLBACK_TYPE DefCanReceiveClear(uint32_t index)
{
(void)index;

DefDriverProcedure(1);
}


uint32_t  DRV_CALLBACK_TYPE DefCanReceiveGetCount(uint32_t index)
{
(void)index;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanSetSpeed(uint32_t index, uint16_t speed)
{
(void)index;
(void)speed;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanSetSpeedUser(uint32_t index, uint32_t value)
{
(void)index;
(void)value;

DefDriverProcedure(1);
return(0);
}


char * DRV_CALLBACK_TYPE DefCanDrvInfo(void)
{
DefDriverProcedure(1);
return(NULL);
}


char * DRV_CALLBACK_TYPE DefCanDrvHwInfo(uint32_t index)
{
(void)index;

DefDriverProcedure(1);
return(NULL);
}


int32_t DRV_CALLBACK_TYPE DefCanSetFilter(uint32_t index, struct TMsgFilter *msg_filter)
{
(void)index;
(void)msg_filter;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanGetDeviceStatus(uint32_t index, struct TDeviceStatus *status)
{
(void)index;
(void)status;

status->CanStatus = CAN_STATUS_UNBEKANNT;
status->FifoStatus = FIFO_STATUS_UNBEKANNT;
status->DrvStatus = DRV_NOT_LOAD;
return(0);
}


void DRV_CALLBACK_TYPE DefCanSetPnPEventCallback(void (DRV_CALLBACK_TYPE *event)(uint32_t index, int32_t status))
{
(void)event;

DefDriverProcedure(1);
}


void DRV_CALLBACK_TYPE DefCanSetStatusEventCallback(void (DRV_CALLBACK_TYPE *event)
  (uint32_t index, struct TDeviceStatus *device_status))
{
(void)event;

DefDriverProcedure(1);
}


void DRV_CALLBACK_TYPE DefCanSetRxEventCallback(void (DRV_CALLBACK_TYPE *event)(uint32_t index,
  struct TCanMsg *msg, int32_t count))
{
(void)event;

DefDriverProcedure(1);
}


void DRV_CALLBACK_TYPE DefCanSetEvents(uint16_t  events)
{
(void)events;

DefDriverProcedure(1);
}


uint32_t DRV_CALLBACK_TYPE DefCanEventStatus(void)
{
DefDriverProcedure(1);
return(1);
}


// EX-Funktionen
int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceCount(int32_t flags)
{
(void)flags;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceList(struct TCanDevicesList **devices_list, int32_t flags)
{
(void)devices_list;
(void)flags;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceListPerform(int32_t flags)
{
(void)flags;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceListGet(struct TCanDevicesList *item)
{
(void)item;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceInfo(uint32_t index, struct TCanDeviceInfo *device_info,
  struct TCanInfoVar **hw_info, uint32_t *hw_info_size)
{
(void)index;
(void)device_info;
(void)hw_info;
(void)hw_info_size;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceInfoPerform(uint32_t index, struct TCanDeviceInfo *device_info)
{
(void)index;
(void)device_info;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetDeviceInfoGet(struct TCanInfoVar *item)
{
(void)item;

DefDriverProcedure(1);
return(0);
}


void DRV_CALLBACK_TYPE DefCanExDataFree(void **data)
{
(void)data;

DefDriverProcedure(1);
}


int32_t DRV_CALLBACK_TYPE DefCanExCreateDevice(uint32_t *index, char *options)
{
(void)index;
(void)options;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExDestroyDevice(uint32_t *index)
{
(void)index;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExCreateFifo(uint32_t index, uint32_t size, TMhsEvent *event_obj, uint32_t event, uint32_t channels)
{
(void)index;
(void)size;
(void)event_obj;
(void)event;
(void)channels;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExBindFifo(uint32_t fifo_index, uint32_t device_index, uint32_t bind)
{
(void)fifo_index;
(void)device_index;
(void)bind;

DefDriverProcedure(1);
return(0);
}


TMhsEvent * DRV_CALLBACK_TYPE DefCanExCreateEvent(void)
{
DefDriverProcedure(1);
return(NULL);
}


int32_t DRV_DRV_CALLBACK_TYPE_TYPE DefCanExSetObjEvent(uint32_t index, uint32_t source, TMhsEvent *event_obj, uint32_t event)
{
(void)index;
(void)source;
(void)event_obj;
(void)event;

DefDriverProcedure(1);
return(0);
}


void DRV_CALLBACK_TYPE DefCanExSetEvent(TMhsEvent *event_obj, uint32_t event)
{
(void)event_obj;
(void)event;

DefDriverProcedure(1);
}


void DRV_CALLBACK_TYPE DefCanExSetEventAll(uint32_t event)
{
(void)event;

DefDriverProcedure(1);
}


void DRV_CALLBACK_TYPE DefCanExResetEvent(TMhsEvent *event_obj, uint32_t event)
{
(void)event_obj;
(void)event;

DefDriverProcedure(1);
}


uint32_t DRV_CALLBACK_TYPE DefCanExWaitForEvent(TMhsEvent *event_obj, uint32_t timeout)
{
(void)event_obj;
(void)timeout;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExInitDriver(char *options)
{
(void)options;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetOptions(uint32_t index, char *options)
{
(void)index;
(void)options;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetAsByte(uint32_t index, char *name, char value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetAsWord(uint32_t index, char *name, int16_t value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetAsLong(uint32_t index, char *name, int32_t value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetAsUByte(uint32_t index, char *name, unsigned char value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetAsUWord(uint32_t index, char *name, uint16_t value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetAsULong(uint32_t index, char *name, uint32_t value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExSetAsString(uint32_t index, char *name, char *value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsByte(uint32_t index, char *name, char *value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsWord(uint32_t index, char *name, int16_t *value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsLong(uint32_t index, char *name, int32_t *value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsUByte(uint32_t index, char *name, unsigned char *value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsUWord(uint32_t index, char *name, uint16_t *value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsULong(uint32_t index, char *name, uint32_t *value)
{
(void)index;
(void)name;
(void)value;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsString(uint32_t index, char *name, char **str)
{
(void)index;
(void)name;
(void)str;

DefDriverProcedure(1);
return(0);
}


int32_t DRV_CALLBACK_TYPE DefCanExGetAsStringCopy(uint32_t index, char *name, char *dest, uint32_t *dest_size)
{
(void)index;
(void)name;
(void)dest;
(void)dest_size;

DefDriverProcedure(1);
return(0);
}


#endif


#ifdef __WIN32__
/***************************************************************/
/*                API Treiber Path ermitteln                   */
/***************************************************************/
#define MAX_PATH_LEN 255

#define DIR_SEPARATOR '\\'
#define DIR_SEPARATOR_STR "\\"

/**************************************************************************/
/*                        C O N S T A N T E N                             */
/**************************************************************************/
#ifdef _WIN64
static const char REG_TINY_CAN_API[] = {"Software\\Wow6432Node\\Tiny-CAN\\API"};
#else
static const char REG_TINY_CAN_API[] = {"Software\\Tiny-CAN\\API"};
#endif
static const char REG_TINY_CAN_API_PATH_ENTRY[] = {"PATH"};

static const char API_DRIVER_DLL[] = {"mhstcan.dll"};
#ifdef _WIN64
static const char API_DRIVER_X64_DIR[] = {"x64"};
#endif
//typedef char *(*TCanDrvInfoCB)(void);

/**************************************************************************/
/*                        F U N K T I O N E N                             */
/**************************************************************************/
static char *MhsStpCpy(char *dest, const char *src)
{
register char *d = dest;
register const char *s = src;

do
  *d++ = *s;
while (*s++);

return(d - 1);
}


static char *MhsStrDup(const char *str)
{
size_t len;
char *new_str;

if (str)
  {
  len = strlen(str) + 1;
  new_str = (char *)malloc(len);
  if (!new_str)
    return(NULL);
  memcpy(new_str, str, len);
  return(new_str);
  }
else
  return(NULL);
}


static char *MhsStrconcat(const char *string1, ...)
{
size_t l;
va_list args;
char *s, *concat, *ptr;

if (!string1)
  return(NULL);

l = 1 + strlen(string1);
va_start(args, string1);
s = va_arg(args, char*);
while (s)
  {
  l += strlen(s);
  s = va_arg(args, char*);
  }
va_end(args);

concat = (char *)malloc(l);
if (!concat)
  return(NULL);
ptr = concat;

ptr = MhsStpCpy(ptr, string1);
va_start (args, string1);
s = va_arg (args, char*);
while (s)
  {
  ptr = MhsStpCpy(ptr, s);
  s = va_arg(args, char*);
  }
va_end (args);

return(concat);
}


static char *MhsCreateFileName(const char *dir, const char *sub_dir, const char *file_name)
{
if (!dir)
  return(MhsStrDup(file_name));
if (!file_name)
  return(NULL);
if (strchr(file_name, DIR_SEPARATOR))
  return(MhsStrDup(file_name));
else
  {
  if (sub_dir)
    {
    if (dir[strlen(dir)-1] == DIR_SEPARATOR)
      {
      if (sub_dir[strlen(sub_dir)-1] == DIR_SEPARATOR)
        return(MhsStrconcat(dir, sub_dir, file_name, NULL));
      else
        return(MhsStrconcat(dir, sub_dir, DIR_SEPARATOR_STR, file_name, NULL));
      }
    else
      {
      if (sub_dir[strlen(sub_dir)-1] == DIR_SEPARATOR)
        return(MhsStrconcat(dir, DIR_SEPARATOR_STR, sub_dir, file_name, NULL));
      else
        return(MhsStrconcat(dir, DIR_SEPARATOR_STR, sub_dir, DIR_SEPARATOR_STR, file_name, NULL));
      }
    }
  else
    {
    if (dir[strlen(dir)-1] == DIR_SEPARATOR)
      return(MhsStrconcat(dir, file_name, NULL));
    else
      return(MhsStrconcat(dir, DIR_SEPARATOR_STR, file_name, NULL));
    }
  }
}


static char *MhsRegGetString(HKEY key, const char *value_name)
{
DWORD type, data_size;
char *str;

type = 0;
data_size = 0;
if ((!key) || (!value_name))
  return(NULL);
// Lnge des Strings ermitteln
if (RegQueryValueExA(key, value_name, 0, &type, NULL, &data_size) != ERROR_SUCCESS)
  return(NULL);
// Wert ist String ?
if (type != REG_SZ)
  return(NULL);
str = malloc(data_size+1);
if (!str)
  return(NULL);
// String lesen
if (RegQueryValueExA(key, value_name, 0, &type, (LPBYTE)str, &data_size) != ERROR_SUCCESS)
  {
  free(str);
  return(NULL);
  }
str[data_size] = '\0';
return(str);
}


static char *MhsRegReadStringEntry(const char *path, const char *entry)
{
HKEY key;
char *value;

value = NULL;
// HKEY_CURRENT_USER ?
if (RegOpenKeyExA(HKEY_LOCAL_MACHINE, path, 0, KEY_QUERY_VALUE, &key) == ERROR_SUCCESS) // KEY_READ
  {
  value = MhsRegGetString(key, entry);
  RegCloseKey(key);
  }
return(value);
}


static int32_t TestApi(const char *file_name)
{
HINSTANCE driver_dll;
TCanDrvInfo drv_info_cb;

drv_info_cb = NULL;
driver_dll = LoadLibraryA(file_name);
if (driver_dll)
  {
  drv_info_cb = (TCanDrvInfo)GetProcAddress(driver_dll, (LPCSTR)"CanDrvInfo");
  FreeLibrary(driver_dll);
  }
if (drv_info_cb)
  return(0);
else
  return(-1);
}


static char *GetApiDriverWithPath(const char *driver_file)
{
char *path, *file_name;
char app_file[MAX_PATH_LEN];
char app_path[MAX_PATH_LEN];
char *ptr;

file_name = NULL;
if ((!driver_file ) || (!strlen(driver_file)))
  driver_file = API_DRIVER_DLL;
if (strchr(driver_file, DIR_SEPARATOR))
  return(MhsStrDup(driver_file));
if ((path = MhsRegReadStringEntry(REG_TINY_CAN_API, REG_TINY_CAN_API_PATH_ENTRY)))
  {
#ifdef _WIN64
  file_name = MhsCreateFileName(path, API_DRIVER_X64_DIR, driver_file);
#else
  file_name = MhsCreateFileName(path, NULL, driver_file);
#endif
  if (TestApi(file_name))
    MhsSafeFree(file_name);
  free(path);
  }
if (!file_name)
  {
  // Programm Path ermitteln
  GetModuleFileNameA(GetModuleHandle(NULL), app_file, MAX_PATH_LEN);
  GetFullPathNameA(app_file, sizeof(app_file), app_path, &ptr);
  app_path[ptr-app_path] = '\0';
  file_name = MhsCreateFileName(app_path, NULL, driver_file);
  if (TestApi(file_name))
    MhsSafeFree(file_name);
  }
return(file_name);
}

#endif


